<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Algorithms</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Algorithms</h1>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Algorithms Overview</h2>
						<ul>
                            <li><b>Algorithm Analysis</b></li>
                            <li><b>Algorithm Design</b></li>
                            <li><b>Big O Notation</b></li>
                            <li><b>Searching Algorithms</b></li>
                            <li><b>Sorting Algorithms</b></li>
						</ul>
                    </section>
					<section>
					    <h2>Objectives</h2>
					    <a href="../objectives.html" target="_blank">Algorithms Objectives</a>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Algorithm Analysis</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li><b>Priori Analysis</b>
								<ul>
									<li style="font-size: 24px;">
										Theoretical analysis of an algorithm: Efficiency of an algorithm is measured by assuming that all other factors, 
										such as processor speed, are constant and have no effect on the implementation.
									</li>
								</ul>
							</li>
							<li><b>Posterior Analysis</b>
								<ul>
									<li style="font-size: 24px;">
										Empirical analysis of an algorithm: The selected algorithm is implemented using a programming language 
										which is then executed on a target machine. In this analysis statistics, such as running time and the space required by an alogirthm, are collected.
									</li>
								</ul>
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Algorithm Complexity</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li><b>Time Factor</b>
								<ul>
									<li style="font-size: 24px;">
										Time is measured by counting the number of key operations, such as counting comparisons in a sorting algorithm.
									</li>
								</ul>
							</li>
							<li><b>Space Factor</b>
								<ul>
									<li style="font-size: 24px;">
										Space is measured by counting the maximum memory space required by the algorithm.
									</li>
								</ul>
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Space Complexity</h3>
						<p style="font-size: 28px;">
							Space complexity of an algorithm represents the amount of memory space required by the algorithm in its life cycle. 
							The space required by an algorithm is equal to the sum of the following two components:
						</p>
						<ul>
							<li style="font-size: 24px;">
								<b>Fixed</b>: The space required to store certain data and variables that are independent of the size of the problem
								(simple variables and constants used, program size, etc.).
							</li>
							<li style="font-size: 24px;">
								<b>Variable</b>: The space required by variables whose size depends on the size of the problem
								(dynamic memory allocation, recursion stack space, etc.).
							</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Time Complexity</h4>
						<p style="font-size: 24px;">
							Time complexity of an algorithm represents the amount of time required by the algorithm to run to completion.
							Time requirements can be defined as a numerical function <b>T(n)</b>, where <b>T(n)</b> can be measured as the number of steps, provided each step consumes constant time.
						</p>
						<p style="font-size: 24px;">
							For example, addition of two n-bit integers takes n steps.
							Consequently, the total computational time is T(n) = c * n,
							where c is the time taken for the addition of two bits.
							Observe that T(n) grows linearly as the input size increases.
						</p>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Algorithm Design</h2>
					</section>
				
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							From the data structure point of view, the following are some important categories of algorithms:
						</p>
						<ul>
							<li style="font-size: 24px;">
								<b>Search</b> - Algorithm to search for an item in a data structure.
							</li>
							<li style="font-size: 24px;">
								<b>Sort </b> - Algorithm to sort items in a certain order in a data structure.
							</li>
							<li style="font-size: 24px;">
								<b>Insert </b> - Algorithm to insert an item in a data structure.
							</li>
							<li style="font-size: 24px;">
								<b>Update</b> - Algorithm to update an existing item in a data structure.
							</li>
							<li style="font-size: 24px;">
								<b>Delete</b> - Algorithm to delete an existing item from a data structure.
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Characteristics of an Algorithm</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							Not all procedures can be called an algorithm. An algorithm should have the following characteristics:
						</p>
						<ul>
							<li style="font-size: 24px;">
								<b>Unambiguous</b>: An algorithm should be clear and unambiguous. Each of the steps/phases as well as their inputs/outputs should be clear and must lead to only one meaning.
							</li>
							<li style="font-size: 24px;">
								<b>Input</b>: An algorithm should have 0 or more well-defined inputs.
							</li>
							<li style="font-size: 24px;">
								<b>Output</b>: An algorithm should have 1 or more well-defined outputs, and should match the desired output.
							</li>
							<li style="font-size: 24px;">
								<b>Finiteness</b>: Algorithms must terminate after a finite number of steps.
							</li>
							<li style="font-size: 24px;">
								<b>Feasibility</b>: Should be feasible with the available resources.
							</li>
							<li style="font-size: 24px;">
								<b>Independent</b>: An algorithm should have step-by-step directions, which should be independent of any programming code.
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>How to Write an Algorithm?</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							There are no well-defined standards for writing algorithms. Algorithms are problem and resource dependent and are never written to support a particular programming code.
						</p>
						<p style="font-size: 28px;">
							All programming languages share basic code constructs like loops (do, for, while), flow-control (if-else), etc. These common constructs can be used to write an algorithm.
						</p>
						<p style="font-size: 28px;">
							Algorithms are written in a step-by-step manner, but that is not always the case. Algorithm writing is a process that is executed after the problem domain has been well-defined. That is, we should know the problem domain for which we are designing a solution.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Example</h4>
						<p style="font-size: 28px;">
							<b>Problem</b>: Design an algorithm to add two numbers and display the result.
						</p>
						<ul>
							<li style="font-size: 24px;">
								<b>Step 1</b> - START ADD
							</li>
							<li style="font-size: 24px;">
								<b>Step 2</b> - get values of a & b
							</li>
							<li style="font-size: 24px;">
								<b>Step 3</b> - c ← a + b
							</li>
							<li style="font-size: 24px;">
								<b>Step 4</b> - display c
							</li>
							<li style="font-size: 24px;">
								<b>Step 5</b> - STOP
							</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Big O Notation</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							Big O notation is the analysis of algorithms and is used to describe an algorithm's usage of computational resources in a way that is independent of a computer's architecture or clock rate
						</p>
						<p style="font-size: 28px;">
							The worst case running time, or memory usage of an algorithm, is often expressed as a function of the length of its input using big O notation
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							An expression in big O notation is expressed as a capital letter <b>"O"</b>, which is generally followed by
							a function in terms of the variable <b>n</b>. The variable <b>n</b> is understood to be the
							size of the input to the function that is being analyzed.
						</p>
						<p style="font-size: 28px;">
							Looks like: <b>O(n)</b>
						</p>
						<p style="font-size: 28px;">
							A statement such as <b>f(x)</b> is  <b>O(n)</b> can be read as "f of x is big Oh of n".
							It is understood that the number of steps to run <b>f(x)</b> is linear with respect to <b>|x|</b> (absolute value of <b>x</b>), the size of the input <b>x</b>.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Upper bound</h3>
						<p><span style="font-size: 0.9em;">A description of a function in terms of big O notation only provides an upper bound on the growth rate of the function.</span></p>
				
						<ul>
							<li style="font-size: 24px;">This means that a function that is<b>O(n)</b> is also, technically, <b>O(n^2 )</b>, <b>O(n^3 )</b>, etc</li>
							<li style="font-size: 24px;">We generally seek to provide the tightest possible bound.</li>
							<li style="font-size: 24px;">If an algorithm is <b>O(n^3 )</b>, but it is also <b>O(n^2)</b>, it is generally best to say <b>O(n^2)</b>.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Why Big O?</h4>
						<ul>
							<li style="font-size: 22px;">Big O notation allows us to compare different approaches for solving problems, and predict how long it might take to run an algorithm on a very large input.</li>
							<li style="font-size: 22px;">Big O notation is particularly concerned with the scalability of a function/algorithm. Big O bounds may not reveal the fastest algorithm for small inputs, but big O will accurately predict the long-term behavior of the algorithm.</li>
							<li style="font-size: 22px;">This is particularly important in the realm of scientific computing. Doing analysis on the human genome or data from Hubble involves input (arrays or lists) of sizes well into the tens of millions (base pairs, pixels, etc).</li>
						</ul>
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3><span style="font-size:0.9em;">Common bounds</span>&nbsp;</h3>
						<p style="font-style: normal; text-align: left;"><b>O(1) Constant Time: </b>
							Even though the constants are huge, they are still constant regardless of the size of the input.</p>
				
						<p style="font-style: normal; text-align: left;"><b>O(lg n) Logarithmic time: </b>
				
						This is faster than linear time. Fastest time bound for <b>searching</b></p>
				
						<p style="font-style: normal; text-align: left;"><b>O(n) Linear Time: </b>
				
							Usually results from algorithms that examine every single bit of input such as using a <b>for</b> loop.</p>
						<p style="font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; font-family: Open Sans, sans-serif; color: rgb(0, 0, 0); text-align: left;"></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3><strong><span style="font-size:0.9em;">Common bounds</span>&nbsp;<span style="font-size:0.7em;">cont</span>.</strong></h3>
						
						<p style="font-style: normal; text-align: left;"><b>O(n lg n) Log-Linear (Linearithmic):</b>
							This is the fastest time bound we can currently achieve for <b>sorting</b> a list of elements</p>
				
						<p style="font-style: normal; text-align: left;"><b>O(n^2) Quadratic Time: </b>
							Often this is the bound when we have <b>nested loops</b></p>
				
						<p style="font-style: normal; text-align: left;"><b>O(2^n) Exponential:</b>
							Really, REALLY big!&nbsp; A number raised to the power of <b>n</b> is slower than <b>n</b> raised to any power.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h4>Big O limits</h4>
						<p>Big O is concerned with the long-term or limiting behavior of a function</p>
						<p></p>
						Recall that <b>lim x^2 = lim 100x^2 = ∞</b>
						<p> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <b>x→∞</b> &nbsp; &nbsp;<b>x→∞</b></p>
						<p></p>
						<ul>
							<p>Go out far enough on a graph and a distinction can't be made between <b>100x^2</b> and <b>x^2</b>.</p>
							<p>When talking about big O notation, always drop coefficient multipliers and keep the dominant terms.</p>
							<p>When analyzing an algorithm and it comes out to <b>O(n) + O(n)</b> it resolves to <b>O(n)</b></p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Constant Terms</h2>
						<p>&nbsp;</p>

						<p style="text-align: left;">Constant terms are always dropped if a variable terms is present</p>
				
						<p style="text-align: left;"> O(800 lg n + 73891) = <b>O(lg n)</b></p>
				
						<p style="text-align: left;">O(73891) by itself with no variable terms present is <b>O(1)</b></p>

				
						<p>&nbsp;</p>					
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Big O question</h2>
						<p>&nbsp;</p>

						<p style="text-align: left;">1. Does <b>O(100n^2) = O(n^2)</b>?</p>
				
						<p style="text-align: left;">2. Does <b>O(1/4 n^3 ) = O(n^3)</b>? &nbsp;</p>
				
						<p style="text-align: left;">3. Does <b>O(n) + O(n) = O(n)</b>?</p>
				
						<p>&nbsp;</p>
				
						<p>&nbsp;</p>
				
						<p>YES: The biggest term dominates the smaller terms</p>
				
						<p>&nbsp;</p>					
					</section>
					
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Big O considerations</h3>
					

						<p style="text-align: left;"><b>Math operations</b>: Consider all mathematical operations to be constant time <b>O(1)</b>.</p>
				
						<p style="text-align: left;"><b>for loops</b>: Functions containing <b>for</b> loops that go through the whole input are generally <b>O(n)</b></p>
				
						<p style="text-align: left;"><b>if statements/conditionals</b>: The complexity of conditionals (ie. <b>if</b> statements) depends on what the condition is. The complexity of the condition can be constant <b>O(1)</b>, linear <b>O(n)</b>, or even worse. </p>		
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Big O considerations cont.</h3>

						<p style="text-align: left;"><b>While loops</b>: Combine the analysis of a conditional with one of a <b>for</b> loop.</p>
					
						<p style="text-align: left;"><b>Nested for loops</b>: Work from the inside out. Figure out the complexity of the innermost loop, then go out a level and multiply</p>
				
						<p style="text-align: left;"><b>Recursion</b>: Can be tricky; think of recursion like a tree. If the tree has lots of branches, it will be more complex than one that has very few branches</p>
				
						
					</section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Complex example</h3>
				
					<pre>
<code data-trim data-noescape>
def count_same_ltrs(a_str, b_str):
    count = 0
    for char in a_str:
        if char in b_str:
            count += 1
    return count
</code>
					</pre>		
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Complex example: explanation</h3>
						</p> 
						The conditional <b>if</b> statement checks if <b>char</b> is in <b>b_str</b>.  This requires that in a worst case scenario for a check on every character in <b>b_str</b>
						<p>Let <b>n = |a str|</b> and <b>m = |b str|</b></p>
						<p>Then, the <b>for</b> loop is <b>O(n)</b></p>
						Each iteration of the <b>for</b> loop executes a conditional check that is, in the worst case, <b>O(n)</b>.
						Since we execute an <b>O(m)</b> check <b>O(n)</b> times, this function is <b>O(n*m) or O(n^2)</b>.
						</p>				
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6A_Part_One_Complexity_Exercises.html">Lab 6A - Part One</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Searching Algorithms</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<p style="font-size: 28px;">A <b>search algorithm</b> solves the problem of retrieving information stored within some data structure.</p>
							<p style="font-size: 28px;">Examples of such structures include, but are not limited to;
								<ul>
									<p style="font-size: 28px;">linked lists</p> 
									<p style="font-size: 28px;">array data structures</p>
									<p style="font-size: 28px;">search trees</p>
								</ul>
							<p style="font-size: 28px;">The appropriate <b>search</b> algorithm often depends, not just on the data structure being searched, but also on any priori knowledge.</p>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Linear Search Algorithm</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							A linear search algorithm is a simple algorithm that starts at the first item in a list and does a check on each item until the item that is being looked for is found or the end of the list is reached.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
"""Linear search example"""
def linearSearch(item, my_list):
    found = False
    position = 0
    while position &lt; len(my_list) and not found:
        if my_list[position] == item:
            found = True
            position = position + 1
    return found
</code>
						</pre>
					</section>	
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<b><p style="font-size: 24px;">""" Driver Code"""</p></b>
						<pre>
<code>
bag = ['book', 'pencil', 'pen', 'note book', 'sharpener', 'eraser']
item = input('What item do you want to check for in the bag?')
itemFound = linearSearch(item, bag)
if itemFound:
    print('Yes, the item is in the bag')
else:
    print('Oops, the item is not in the bag')
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Linear Search</p>
						<p>Big O complexity of <b>O(n)</b></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Binary Search</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">Divide and Conquer</p>
						<p style="font-size: 24px;">	
							The idea of <b>binary search</b> is to use the information that the items are <b>sorted</b> and reduce the time complexity to <b>O(Log n)</b>.</p>
						<ul>
							<li style="font-size: 26px;" id="left">Search a <b>sorted</b> array by repeatedly dividing the search interval in half.</li>
							<li style="font-size: 26px;" id="left">Begin with an interval covering the whole array.</li>
							<li style="font-size: 26px;" id="left">If the value of the search key is less than the item in the middle of the interval, narrow the interval to the lower half.</li>
							<li style="font-size: 26px;" id="left">Otherwise narrow it to the upper half.</li>
							<li style="font-size: 26px;" id="left">Repeatedly check until the value is found or the interval is empty.</li>
						</ul>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">Binary Search</p>
						<img src="../Assets/BinSearch.png" alt="BinSearch">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p style="font-size: 28px;">
							We basically ignore half of the elements just after one comparison.
						</p>
							<ul>
								<p style="font-size: 26px;"><b>Binary flow:</b></p>

								<li style="font-size: 24px;">Let <b>x</b> be the item searched for</li>

								<li style="font-size: 24px;">Compare <b>x</b> with the middle element.</li>
								<li style="font-size: 24px;">If <b>x</b> matches with middle element, we return the middle index.</li>
								<li style="font-size: 24px;">
									Else If <b>x</b> is greater than the middle element, then <b>x</b> can only lie in right half subarray after the middle element. So we recur for right half.
								</li>
								<li style="font-size: 24px;">Else (<b>x</b> is smaller) recur for the left half.</li>
							</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def binary_search(target, sorted_list):
    left = 0  <b># first index in list</b>
    right = len(sorted_list) - 1   <b># last index in list</b>
    while left <= right:
        midpoint = (left + right) // 2   <b># approximate middle index</b>
        if target == sorted_list[midpoint]:
            return midpoint
        elif target < sorted_list[midpoint]:
            right = midpoint - 1   <b># move right "pointer" to the midpoint - 1</b>
        else:
            left = midpoint + 1
    return -1
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<b><p style="font-size: 24px;">"""Driver code"""</p></b>
						<pre>
<code>
target = 3
sorted_list = [1,2,3,4,5,6,7,8,9]
response = binary_search(target, sorted_list)
if response == -1:
    print("Item not in list")
else:
    print(f"Item found at index {response}")
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Binary Search</p>
						<p>Big O complexity of <b>O(lg n)</b></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6A_Part_Two_Search_Exercises.html">Lab 6A - Part Two</a>
                    </section>
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Sorting Algorithms</h2>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p> Sorting algorithms specify the particular order to arrange data.</p>

						<p>The importance of sorting lies in the fact that searching for data can be optimized if the data is stored in a sorted manner.</p>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Six implementations of sorting in python.</p>
						<ul>
							<li>Bubble Sort</li>
							<li>Insertion Sort</li>
							<li>Shell Sort</li>
							<li>Selection Sort</li>
							<li>Merge Sort</li>
							<li>Quick Sort</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Bubble Sort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>
							Bubble sort is a comparison-based algorithm in which each pair of adjacent elements is compared and the elements are swapped if they are not in order.
						</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def bubble_sort(input_list):
    """Swap the elements to arrange in order"""
    for iter_num in range(len(input_list) - 1, 0, -1):
        for idx in range(iter_num):
            if input_list[idx] > input_list[idx + 1]:
                temp = input_list[idx]
                input_list[idx] = input_list[idx + 1]
                input_list[idx + 1] = temp
    return input_list
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/bubbleSorta.png" alt="Bubble Sort">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Bubble Sort</p>
						<p>Big O complexity of <b>O(n^2)</b></p>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Insertion Sort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/insertionsorta.png" alt="Insertion Sort">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<ul>
							<li>Start by sorting the first two elements by comparing them and placing in order.</li>
							<li>Then pick the third element and find its proper position among the previous two sorted elements.</li>
							<li>Continue on adding more elements to the already sorted list by putting them in their proper position.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def insertion_sort(input_list):
    for i in range(1, len(input_list)):
        j = i - 1
        nxt_element = input_list[i]
        """ Compare the current element with next one """
        while(input_list[j] > nxt_element) and (j >= 0):
            input_list[j + 1] = input_list[j]
            j = j - 1
        input_list[j + 1] = nxt_element
</code>
						</pre>
					</section>
						
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Insertion Sort</p>
						<p>Big O complexity of <b>O(n^2)</b></p>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Shell Sort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/shellsorta.png" alt="Shell Sort">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>The Shell sort involves breaking an original list into sublists.</p> 
						<ul>
							<li>Each sublist is then sorted using an <b>insertion sort</b>.</li>
							<li>The sublists are chosen using an incrementer <b>i</b> or <b>gap</b>.</li>
							<li>The sublist is made of items that are <b>i</b> or <b>gap</b> apart.</li>
							<li>The algorithm finds the <b>gap</b> by equating it to half of the length of the list size and then starts sorting all elements in it.</li>
							<li>Then the <b>gap</b> is reset until the entire list is sorted.</li>
						</ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def shellSort(input_list):
    gap = len(input_list) // 2
    while gap > 0:
        for i in range(gap, len(input_list)):
            temp = input_list[i]
            j = i
            """ Sort the sub list for this gap"""
            while j >= gap and input_list[j - gap] > temp:
                input_list[j] = input_list[j - gap]
                j = j - gap
            input_list[j] = temp
        """ Reduce the gap for the next element"""
        gap = gap //2
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Shell Sort</p>
						<p>Big O complexity of <b>O(n^2)</b></p>	
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Selection Sort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/selectionsort.png" alt="Selection Sort">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p></p>In selection sort we start by finding the minimum value in a given list and move it to a sorted list.</p> 
						<p>Then we repeat the process for each of the remaining elements in the unsorted list.</p>
						<p>The next element entering the sorted list is compared with the existing elements and placed at its correct position.</p>
						
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def selection_sort(input_list):
    for idx in range(len(input_list)):
        min_idx = idx
        for j in range(idx + 1, len(input_list)):
            if input_list[min_idx] > input_list[j]:
                min_idx = j
        """Swap the minimum value with the compared value"""
        input_list[idx], input_list[min_idx] = input_list[min_idx], input_list[idx]
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Selection Sort</p>
						<p>Big O complexity of <b>O(n^2)</b></p>	
					</section>
				</section>
				<section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Divide and Conquer Sorting Algorithms</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Merge Sort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<img src="../Assets/mergesort.png" alt="Merge Sort">
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Divide and Conquer</b></p>
						<p><i>Faster Sorting</i></p>
						<p>Merge sort divides an array into equal halves and then combines them in a sorted manner</p>		
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<pre>
<code>
def merge_sort(unsorted_list):
    if len(unsorted_list)&lt;=1:
        return unsorted_list
    """Find the middle point and divide it"""
    middle = len(unsorted_list) // 2
    left_list = unsorted_list[:middle]
    right_list = unsorted_list[middle:]
    left_list = merge_sort(left_list)
    right_list = merge_sort(right_list)
    return list(merge(left_list, right_list))
</code>
						</pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code>
"""Merge the sorted halves"""
def merge(left_half ,right_half):
    res = []
    while len(left_half) != 0 and len(right_half) != 0:
        if left_half[0] &lt; right_half[0]:
            res.append(left_half[0])
            left_half.remove(left_half[0])
        else:
            res.append(right_half[0])
            right_half.remove(right_half[0])
    if len(left_half) == 0:
        res = res + right_half
    else:
        res = res + left_half
    return res
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Merge Sort</p>
						<p>Big O complexity of <b>O(n lg n)</b></p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Quicksort</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p><b>Divide and Conquer</b></p>
						<p><i>Faster Sorting</i></p>
						<p>
							Quick sort uses the idea of a <b>pivot</b> for sorting. <b>Pivot</b> is usually the midpoint of the items
						</p>
						<p>The <b>pivot</b> is used to partition the list so that the items can be sorted to one side of the <b>pivot</b> or the other.</p>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <pre>
<code>
    def partition(my_list, left, right):
    #find the pivot and exchange it with the last item
    middle = (left + right) //2
    pivot = my_list[middle]
    my_list[middle] = my_list[right]
    my_list[right] = pivot 
    # set boundary point for first position
    boundary = left
    #moves items less than the pivot to the left
    for index in range(left, right):
        if my_list[index] < pivot:
            swap(my_list, index, boundary)
            boundary += 1
    #exchange the pivot item and boundary
    swap(my_list, right, boundary)
    return boundary    
</code>
                        </pre>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<p>Quick Sort</p>
						<p>Big O complexity of <b>O(n lg n)</b></p>
					</section>
                    <section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
                        <h2>Labs</h2>
                        <a href="../Lab_6A_Part_Three_Sort_Exercises.html">Lab 6A - Part Three</a>
                    </section>
				</section>
                <section>
                    <section>
                        <h2>Questions?</h2>                
                    </section>    
                </section>
                <section>
                    <section>
                        <h2>Summary</h2>
						<ul>
                            <li><b>Algorithm Analysis</b></li>
                            <li><b>Algorithm Design</b></li>
                            <li><b>Big O Notation</b></li>
                            <li><b>Searching Algorithms</b></li>
                            <li><b>Sorting Algorithms</b></li>
						</ul>
                    </section>
                </section>
				
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>		
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>
